package EDU.auburn.VGJ.gui;

import java.util.*;
import java.net.*;

public class Modules {

  private int NumberOfDir;
  private int NumberOfMod;
  private Vector DirList;
  private Vector ModList;
  private Hashtable ModHash;
  private Hashtable DirHash;
  private Hashtable shapeHash;
  
  private ModuleDesc curMod;
  private int k;
  private String readString;

  public Modules(URL ModulesTxt) {
    // int idx;
    // String ss,module,directory;
    // while(notEOF) {
    // readString = "webflow.modules.QuantumSimulations.FileName";

    // idx=s.lastIndexOf(".");
    // module = s.substring(idx);
    // ss = s.substring(0,idx-1);
    // idx=ss.lastIndexOf(".");
    // directory = ss.substring(idx);
  }

  public Modules() {     
    DirList = new Vector();
    ModList = new Vector();
    ModHash = new Hashtable();
    DirHash = new Hashtable();
    addModule("QS","PutFile","webflow.modules.QuantumSimulations.Putfile",1,1, "aga.npac.syr.edu:2955");
    addModule("QS","GetFile","webflow.modules.QuantumSimulations.Getfile",1,2, "aga.npac.syr.edu:2955");
    addModule("QS","FileBrowser","webflow.modules.QuantumSimulations.FileBrowser",0,1, "aga.npac.syr.edu:2955");
    addModule("Frog","Input","webflow.modules.Frog.Input",0,1, "aga.npac.syr.edu:2955");
    addModule("Frog","Output","webflow.modules.Frog.Output",1,0, "aga.npac.syr.edu:2955");
    NumberOfDir = DirList.size();
    NumberOfMod = ModHash.size();
    shapeHash = new Hashtable();
    shapeHash.put("0",new Integer(0));
    shapeHash.put("1",new Integer(2));
    shapeHash.put("2",new Integer(4));
    shapeHash.put("3",new Integer(0));
    shapeHash.put("10",new Integer(5));
    shapeHash.put("11",new Integer(1));
    shapeHash.put("12",new Integer(7));
    shapeHash.put("13",new Integer(8));
    shapeHash.put("20",new Integer(6));
    shapeHash.put("21",new Integer(9));
    shapeHash.put("22",new Integer(10)); 
    shapeHash.put("23",new Integer(0)); 
    shapeHash.put("30",new Integer(0)); 
    shapeHash.put("31",new Integer(0)); 
    shapeHash.put("32",new Integer(0)); 
    shapeHash.put("33",new Integer(3));
  }

    private void addModule(String directory, String name, String Class,
                           int In, int Out, String server) {

     if(DirHash.get(directory) == null) {
          DirList.addElement(directory);
          DirHash.put(directory,"1");
     } 
     
     ModuleDesc m = new ModuleDesc(name,directory,In,Out,Class);
     m.setServer(server);
     ModList.addElement(directory+"."+name);
     ModHash.put(directory+name,m);
  }


  public String getModuleClass(String ModuleName, String Dir) {
      curMod=(ModuleDesc)ModHash.get(Dir+ModuleName);
      return curMod.getModuleClass();
  }

  public String getModuleServer(String ModuleName, String Dir) {
      curMod=(ModuleDesc)ModHash.get(Dir+ModuleName);
      return curMod.getServer();
  }

  public void setModuleServer(String ModuleName, String Dir, String newServer) {
      curMod=(ModuleDesc)ModHash.get(Dir+ModuleName);
      curMod.setServer(newServer);
    }

  public int getNumberInPorts(String ModuleName, String Dir) {
      curMod=(ModuleDesc)ModHash.get(Dir+ModuleName);
      return curMod.getInPorts();
  }

  public int getNumberOutPorts(String ModuleName, String Dir) {
      curMod=(ModuleDesc)ModHash.get(Dir+ModuleName);
      return curMod.getOutPorts();
  }

  public int getShape(String ModuleName, String Dir) {
      int inport = getNumberInPorts(ModuleName,Dir);
      int outport = getNumberOutPorts(ModuleName,Dir);
      int value = inport*10+outport;
      String pcode = (new Integer(value)).toString(); 
      Integer shape = (Integer)shapeHash.get(pcode);
      int sshape = shape.intValue();
      return sshape;
  }

  public int getNumberOfDir() {
   return NumberOfDir;
  }

  public String getDirName(int i) {
   return (String)DirList.elementAt(i);
  }

  public int getDirSize(String DirName){
   int ds = 0;
   for(k=0;k<NumberOfMod;k++) {
    if(((String)ModList.elementAt(k)).startsWith(DirName)) ds++;
   }
   return ds;
  }

  public Vector getModuleList(String DirName) {
    int idx;
    String ss;
    Vector ml=new Vector();
    for(k=0;k<NumberOfMod;k++) {
      ss = (String)ModList.elementAt(k);
      if(ss.startsWith(DirName)) {
        idx = ss.indexOf(".")+1;
        ml.addElement(ss.substring(idx));
      }
    }
   return ml; 
  }

}
